#------------------------------------------------------------------------------
sub EditConfig {
	my $Info="$pdurl/help";

	my $hidden=Hidden();
	my $select;

	Error("Configuration file $ConfigDir/$configuration not found") unless -f "$ConfigDir/$configuration";
	#require "$ConfigDir/$configuration";

	ParseConfig("$ConfigDir/$configuration");

	Header("Configuration file: $configuration",'javascript');

	print <<EOF;
<table border=0 width=80% bgcolor=silver cellspacing=1>
<tr bgcolor=teal>
 <td colspan=3 align=center valign=center>
 <div class=title>Postcard Direct Configuration<br></div>
 <div class=small>Configuration file: $configuration</div>
 </div>
</td>
</tr>

<form action=$script method=post>
$hidden
EOF

	Section("Essential Configuration Section");
	Textfield("WebRoot","The URL to the top level of your website");
	Textfield("TopLevel","Full directory path to the toplevel of your website");
	Textfield("URLAlias","URL alias (if used)");

	Section("Mail Configuration Section");

	#if ($MailServer and ! $Sendmail) {
	#	$select="SMTP,Sendmail";
	#}
	#else {
	#	$select="Sendmail,SMTP";
	#}

	#Selectfield("Mail Method","Select SMTP if you are on a Win/NT system or your server doesn't run sendmail",$select);
	#Option("SendmailQueue","If sendmail is used, you can choose to queue mail");
	Textfield("MailServer","Name of SMTP mailserver (if SMTP mail is used)");
	Textfield("Subject","Default mail subject if none is specified");

	Section("Mail Sender Section");
	Textfield("SenderEmail","Mail address of the postcard sender");
	Textfield("SenderName","Name of the postcard sender");
	Textfield("ReplyTo","Reply to address");

	Section("Language Options");
	#$select='en,de,se';
	#$select =~ s/$Lang//;
	#$select = "$Lang,$select";
	#$select =~ s/,,/,/;
	#Selectfield("Lang","Default language",$select);

	#Section("Message Wrap Options");
	Textfield("WrapText","Wrap text at the specified column size");

	Section("Logging Options");
	Textfield("Logfile","Location of the log file");
	#Option("EnableLogging","Enable logging");
	#Option("LogSummary","Report just the summary information");

	Section("Remote Images Section");
	Textfield("RemoteSites","File containing a list of allowable sites for remote images");
	Textfield("CacheExpiry","Number of days to store remote images in the cache");

	Section("Mode Section");

	#if ($Mode eq 'direct') {
	#	$select='direct,traditional';
	#}
	#else {	
	#	$select='traditional,direct';
	#}

	#Selectfield("Mode","Default mode of operation",$select);
	Textfield("PostcardDir","Directory to store postcards if traditional mode is selected");
	Textfield("Traditional","Template containing message sent to receipients of traditional postcards","edit");
	Textfield("PostcardAge","Maximum age in days to store traditional postcards");

	Section("Requires Section");
	#Option("RequireSenderName","Require sender to specify their name");
	#Option("RequireReceiverName","Require the name of the recipient");
	#Option("RequireMessage","Require a postcard message is entered");
	#Option("StrictEmailCheck","Do additional checks for a valid email address");
	#Option("Checkdomain","Check email addresses have a valid domain name");
	#Option("AllowHtml","Allow HTML in the message");
	#Option("CheckBadUsers","Check email addresses for bad users");
	#Option("CheckBadWord","Check message for banned words");
	
	Section("List Files Section");
	Textfield("MidiList","File containing list of midi files","edit");
	Textfield("ObjectList","File containing list of allowed objects","edit");
	Textfield("DesignList","File containing list of all the postcard designs","edit");
	Textfield("BadwordsList","File containing list of banned words","edit");
	Textfield("BadusersList","File containing list of banned users","edit");
	Textfield("MimeTypes","File containing list of MIME types","edit");
	Textfield("DomainsList","File containing list of valid domain names","edit");
	
	Section("Anti-Leech Section");
	#Option("AntiLeech","Set anti-leech mode on");
	Textfield("RefererList","List of referring sites allowed access","edit");
	
	Section("Directory Locations Section");
	Textfield("MidiDir","Location of the midi directory");
	Textfield("AdminDir","Location of the admin directory");
	Textfield("DesignDir","Location of the designs directory");
	Textfield("ListsDir","Location of the lists directory");
	Textfield("TemplateDir","Location of the templates directory");

	Section("Templates Section");
	Textfield("Form","Default input form");
	Textfield("Sent","Default template for sent mail");
	Textfield("Error","Default template for errors");
	Textfield("InputError","Default template for user input errors");
	
	
	print <<EOF;
<tr>
<td colspan=3>&nbsp;</td>
</tr>

<tr>
<td colspan=3><hr></td>
</tr>

<tr>
<td colspan=3>
<input type=submit name=action value=SaveConfig>&nbsp;
<input type=submit name=action value=Cancel>
</td>
</tr>

</table>
</form>

</div>

</body>
</html>
EOF
}

#------------------------------------------------------------------------------
sub Selectfield {
	my ($name,$description,$list)=@_;

	my $fieldname=$name;
	$fieldname =~ s/ //g;
	$fieldname = lc($fieldname);

	print <<EOF;
<tr>
<td>$name</td>
<td><select name=$fieldname>
EOF
	foreach my $option (split(',',$list)) {
		print "<option>$option</option>\n";
	}

	print <<EOF;
<td><small>$description.</small>&nbsp;
<a href="JavaScript: help('$fieldname')"><img src=$Images/help.gif alt="More info" border=0></a>
</td>
</tr>

<tr>
<td colspan=3><hr></td>
</tr>
EOF
}

#------------------------------------------------------------------------------
sub Option {
	my ($name,$description,$switch)=@_;

	my $fieldname=$name;
	$fieldname =~ s/ //g;
	$fieldname = lc($fieldname);

	my ($on,$off);

	if ($$name) {
		$on='checked';
	}
	else {
		$off='checked';
	}
	
	print <<EOF;
<tr>
<td>$name</font></td>
<td>
<input type=radio name=$fieldname value=on $on>on
<input type=radio name=$fieldname value=off $off>off
</td>
<td><small>$description.</small>&nbsp;
<a href="JavaScript: help('$fieldname')"><img src=$Images/help.gif alt="More info" border=0></a>
</td>
</tr>

<tr>
<td colspan=3><hr></td>
</tr>
EOF
}

#------------------------------------------------------------------------------
sub ParseConfig {
	my $config=shift;
	my ($var,$value);

	open(CONFIG,$config) or Error("Can not open configuration $config",$!);

	while (<CONFIG>) {
		next if (/^#/ or /\s*$/);
		($var,$value)=split(/=/);
		$var =~ s/\$//;
		$value =~ s/[\",\',;]//g;
		$configname{$var}=$value;
	}

	close(CONFIG);

	#return %configname;
}

#------------------------------------------------------------------------------
sub Textfield {
	my ($name,$description,$directive)=@_;

	my ($edit,$value);

	if ($configname{$name}) {
		 $value=$configname{$name};
	}
	else {
		$value='';
	}

	#my $value=$$name;

	#my $length=length($value);
	#$length=40 if ($length > 40);
	my $length=45;

	if ($directive eq 'edit') {
		my $file=$value;
		$file =~ s!$pdroot/!!;
		$edit=qq(<a href="Javascript: edit('pdedit.cgi?file=$file')" onMouseOver="window.status='Edit File'; return true" onMouseOut="window.status=''; return true">Edit</a>);
	}

	print <<EOF;
<tr>
<td>$name</td>
<td><input type=text size=$length name=$name value="$value"></td>
<td><small>$description.</small>&nbsp;$edit
<a href="JavaScript: help('$name')"
  onMouseOver="window.status='More information'; return true" 
  onMouseOut="window.status=''; return true">
<img src=$Images/help.gif alt="More info" border=0></a>
</td>
</tr>

<tr>
<td colspan=3><hr></td>
</tr>
EOF
}

#------------------------------------------------------------------------------
sub Section {
	my $title=shift;

	print <<EOF;

<tr bgcolor=green>
<td colspan=3>
<div class=subtitle>$title</div></td>
</tr>

<tr>
<td colspan=3><hr></td>
</tr>

EOF
}

#------------------------------------------------------------------------------
